#include "lib-gfx.c"
#include <math.h>

//-------------------------------------------------------------------------------------------------
void drawLineX(unsigned long x,unsigned long y, unsigned int length, u32 colour){
	unsigned char *pp;	
	pp = GetVramAddr(x,y);
	
	unsigned int i;

	for(i=0; i<length; i++)
	{
		

		pp = GetVramAddr(x+i,y);
		*(unsigned short *)pp = colour;               		//*pp = colour;
		
	}
}

//-------------------------------------------------------------------------------------------------
void drawLineY(int x,int y,int length, u32 colour){
	unsigned char *pp;
	pp = GetVramAddr(x,y);
	
	unsigned int i;

	for(i=0; i<length; i++)
	{
		
		pp = GetVramAddr(x,y+i);
		*(unsigned short *)pp = colour;               		//*pp = colour;
		
	}
}

//-------------------------------------------------------------------------------------------------
void fillRect(unsigned long x,unsigned long y,unsigned long w,unsigned long h,u32 col)
{
	unsigned char *vptr0;		//pointer to vram
	unsigned char *vptr;		//pointer to vram
	unsigned long xx,yy;
	
	vptr0=GetVramAddr(x,y);
	for (yy=0; yy<h; yy++) {
		vptr=vptr0;
		for (xx=0; xx<w; xx++) {
			*(unsigned short *)vptr=col;
			vptr+=2;
		}
		vptr0+=512*2;
	}
	
}

//-------------------------------------------------------------------------------------------------
void drawRect(int x,int y, int w, int h, u32 colour){
	drawLineX(x,y,w,colour);
	drawLineX(x,y+h,w,colour);
	drawLineY(x,y,h,colour);
	drawLineY(x+w,y,h,colour);
}

//-------------------------------------------------------------------------------------------------
void drawCircle(int centX, int centY, int radius, u32 colour){
	float deg=0;
	long x,y;
	while(deg < 6.4){
		x = (long)(radius * cosf(deg));
      	y = (long)(radius * sinf(deg));
		deg = deg + 0.005;
		PutPixel(x+centX,y+centY,colour);
	}
}
