/*********************************************************************
 * 
 *  Test Graphics
 *  Gamblore
 */
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <stdlib.h>
#include <string.h>

#include "draw.c"
#include "homebutton.c"

#define printf	pspDebugScreenPrintf
PSP_MODULE_INFO("Tank", 0, 1, 1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

/* game structs and variables */
typedef struct{
	int x;
	int y;
	int velY;
} bullet;

typedef struct{
	int x;
	int y;
} player;

typedef struct{
	int x;
	int y;
	int velY;
} enemy;

bullet shots[2];
enemy blocks[5];
int actShots = 0;
int timeShot = 0;
player tank = {70,238};

//-------------------------------------------------------------------------------------------------
void drawBullet(bullet t){
	drawLineY(t.x-1,t.y,3,WHITE);
	drawLineY(t.x,t.y,3,WHITE);
	drawLineY(t.x+1,t.y,3,WHITE);
}

//-------------------------------------------------------------------------------------------------
void createBullet(void){
	if (actShots < 3) {
		bullet b = {tank.x+16,tank.y,7};
		shots[actShots] = b;
		actShots++;
		timeShot = 3;
	}
}

//-------------------------------------------------------------------------------------------------
void shiftBullets(){
	shots[0] = shots[1];
	shots[1] = shots[2];
	actShots--;
}

//-------------------------------------------------------------------------------------------------
void drawTank(int x, int y, u32 colour){
	long i;
	drawLineX(x+14 ,y+4 ,4 , colour);
	drawLineY(x+14 ,y+4 ,10 , colour);
	drawLineY(x+18 ,y+4 ,10 , colour);
	drawLineX(x+10 ,y+13 ,4 , colour);
	drawLineX(x+18 ,y+13 ,4 , colour);
	drawLineY(x+10 ,y+13 ,10 , colour);
	drawLineY(x+22 ,y+13 ,10 , colour);
	drawLineX(x+5 ,y+23 ,24 , colour);
	drawLineX(x+3 ,y+24 ,2 , colour);
	drawLineX(x+28 ,y+24 ,2 , colour);
	drawLineY(x+3 ,y+24 ,7 , colour);
	drawLineY(x+29 ,y+24 ,7 , colour);
	for(i=0;i<4;i++){
		drawCircle((x+7)+(i*6),(y+28),3,colour);
	}
	drawLineX(x+3 ,y+31 ,2 , colour);
	drawLineX(x+28 ,y+31 ,2 , colour);
	drawLineX(x+5 ,y+32 ,24 , colour);
}

//-------------------------------------------------------------------------------------------------
void drawEnemies(int x, int y, u32 colour){
	drawLineX(x ,y ,16 , colour);
	drawLineY(x ,y , 16, colour);
	drawLineY(x+16, y, 16, colour);
	drawLineX(x, y+16, 16, colour);
}

//-------------------------------------------------------------------------------------------------
void drawBullets(){
	int i;
	for (i=0;i<actShots;i++){
		bullet b = shots[i];
		if (b.y < 0)
		{	
			shiftBullets();
		}
		else{
		drawBullet(b);

		b.y = b.y - b.velY;
		shots[i] = b;
		}
	}
}

//-------------------------------------------------------------------------------------------------
void drawScreen(){
	swapActive();
	ClearScreen(BLACK);
	drawRect(1,1,478,270,WHITE);
	drawTank(tank.x,tank.y,WHITE);
	drawBullets();
	swapBuffer();
}

//-------------------------------------------------------------------------------------------------
void moveTank(int dir){ // -1 left 1 right 0 dont move
	if (dir == -1){
		tank.x = tank.x - 3;
	} else if (dir == 1){
		tank.x = tank.x + 3;
	} else if (dir == 0){}
	if (tank.x < 0){
		tank.x = 0;
	} else if (tank.x > 448){
		tank.x = 448;
	}
	
}
//-------------------------------------------------------------------------------------------------
void keyboardControl()
{
	SceCtrlData ctrl;
	sceDisplayWaitVblankStart();
	sceCtrlReadBufferPositive(&ctrl, 1); 
	if (ctrl.Buttons & PSP_CTRL_UP) { 

	} else if (ctrl.Buttons & PSP_CTRL_DOWN) { 
		
	} else if (ctrl.Buttons & PSP_CTRL_LEFT) { 
		moveTank(-1);
	} else if (ctrl.Buttons & PSP_CTRL_RIGHT) { 
		moveTank(1);
	} else if (ctrl.Buttons & PSP_CTRL_CIRCLE && timeShot == 0) {
		createBullet();
	}
}

//-------------------------------------------------------------------------------------------------
int main(int argc,char *argv[])
{
	pspDebugScreenInit();
	
	printf("Setting Up Callbacks...");
	SetupCallbacks();
	printf("Setting Up Callbacks...Done");
	printf("InitScreen!");
	InitScreen();
	
	drawScreen();
	
	while (1) {
		int i = 0;
		for (i = 0; i < 5; i++) {keyboardControl();}
		if (timeShot == 0);
		else{timeShot--;}
		drawScreen();
		
	}

    return 0;
}
